export class CardAction {
    async componentWillLoad() {
        if (!this.icon && !this.label) {
            console.error('You must define an icon or a label');
            return Promise.reject();
        }
        if (this.icon && !this.label) {
            console.warn('You should define a label in addition to the icon');
        }
    }
    render() {
        return;
    }
    static get is() { return "materials-card-action"; }
    static get encapsulation() { return "shadow"; }
    static get originalStyleUrls() { return {
        "$": ["card-action.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["card-action.css"]
    }; }
    static get properties() { return {
        "label": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": "The action label. If an icon is provided, it will be render as a title"
            },
            "attribute": "label",
            "reflect": false
        },
        "icon": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": "Use an icon for this action"
            },
            "attribute": "icon",
            "reflect": false
        },
        "onAction": {
            "type": "unknown",
            "mutable": false,
            "complexType": {
                "original": "Function",
                "resolved": "Function",
                "references": {
                    "Function": {
                        "location": "global"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": "Function triggered after this action is pressed"
            }
        },
        "fullBleed": {
            "type": "boolean",
            "mutable": false,
            "complexType": {
                "original": "false",
                "resolved": "boolean",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": "Set true to render this action as a single action button taking up the entire width of the action row\nUse if you have only one card action"
            },
            "attribute": "full-bleed",
            "reflect": false
        }
    }; }
}
