import { r as registerInstance, c as createEvent } from './index-0b18a276.js';

const DatatableAction = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        /** Mark this datatable action as displayed */
        this.display = true;
        /** The datatable-action color, it can be either :
         *  - a predifined value : 'primary', 'secondary', 'error'.
         *  - an hexa color code : #225566, #CCC.
         *  - a css named color : red, blue.
        */
        this.color = 'primary';
        this.pressEvent = createEvent(this, "press", 7);
    }
    /** Trigger a press event */
    async TriggerPress(e) {
        this.pressEvent.emit(e);
    }
    render() {
        return;
    }
    static get style() { return ""; }
};

export { DatatableAction as materials_datatable_action };
