import { EventEmitter } from '../../stencil-public-runtime';
export declare class Checkbox {
    /** The checkbox value */
    value: string | number;
    /** Mark the checkbox as checked */
    checked: boolean;
    /** The checkbox label (Optionnal) */
    label?: string;
    /** If a label is provided, where should it be aligned ? */
    alignLabel: 'left' | 'right';
    /** Mark the checkbox as disabled */
    disabled: boolean;
    /** Make the checkbox appear indeterminate */
    indeterminate: boolean;
    /** Color of the checkbox */
    color: 'primary' | 'accent' | 'secondary' | 'danger' | string;
    /** Checkbox name */
    name: string;
    /** Change event emitted when checkbox value changes */
    change: EventEmitter;
    private mdcCheckbox;
    private checkboxDiv;
    componentDidLoad(): void;
    componentDidUnload(): void;
    getCheckboxClasses(): {
        'mdc-checkbox': boolean;
        'mdc-theme--primary': boolean;
        'mdc-theme--error': boolean;
    };
    renderCheckbox(): any;
    renderCheckboxWithLabel(): any;
    render(): any;
}
