/// <reference types="node" />
import { EventEmitter } from "events";
export declare class DatatableAction {
    /** The datatable action label */
    label: string;
    /** Mark this datatable action as displayed */
    display: boolean;
    /** Render an icon (from material-icons library) */
    icon: string;
    /** The datatable-action color, it can be either :
     *  - a predifined value : 'primary', 'secondary', 'error'.
     *  - an hexa color code : #225566, #CCC.
     *  - a css named color : red, blue.
    */
    color: 'primary' | 'secondary' | 'error' | string;
    /** Emitted when it get pressed */
    pressEvent: EventEmitter;
    /** Trigger a press event */
    TriggerPress(e: any): Promise<void>;
    render(): void;
}
