import { EventEmitter } from '../../stencil-public-runtime';
export declare class Datepicker {
    host: HTMLMaterialsDatepickerElement;
    currentMonth: Date;
    /** Display year picker on the element */
    yearPicker: boolean;
    /** Display month picker on the element */
    monthPicker: boolean;
    /** Display button for selecting today's date */
    todayPicker: boolean;
    /** Display button to empty value of the element */
    nullable: boolean;
    /**
     * Used to highlight a time period such as : from Monday to Sunday
     */
    dateRange: {
        start: Date;
        end: Date;
    };
    /** Event emitted when new date is selected */
    dateSelectedUpdate: EventEmitter<Date>;
    /**
     * Used to display current selected date
     */
    dateSelected: Date;
    componentWillLoad(): void;
    componentDidLoad(): void;
    dateSelectedClick(date: Date, old?: any): void;
    isValidDate(d: any): Date;
    addYear(nb: number): void;
    addMonth(nb: number): void;
    addDays(date: any, days: any): Date;
    setDateSelected(date: Date): void;
    startOfWeek(d: Date): Date;
    getDaysOfMonth(): any[];
    getClasses(day: Date, index: any): {
        'day-overview ': boolean;
        'mdc-ripple-surface': boolean;
        'mdc-ripple-surface--primary': boolean;
        'pointer': boolean;
        'day-current': boolean;
        'day-in-month': boolean;
        'day-selected': boolean;
        'in-selected-range': boolean;
    };
    isInMonth(day: any, week: any): boolean;
    isCurrentDay(day: Date): boolean;
    isSameDate(): boolean;
    render(): any;
}
