import { MDCDialog } from '@material/dialog';
import { EventEmitter } from '../../stencil-public-runtime';
import { DialogAction } from './dialog-action';
export declare class Dialog {
    host: HTMLMaterialsDialogElement;
    dialogEl: any;
    bodyElement: HTMLElement;
    mdcDialog: MDCDialog;
    /** Event emitted when acceptButton is clicked */
    accept: EventEmitter;
    /** Event emitted when cancelButton is clicked */
    cancel: EventEmitter;
    /**
     * @deprecated since 1.1.0 : dialog scroll automatically
     */
    scrollable: boolean;
    /**
     * @deprecated since 1.1.0 : not used
     */
    items: string[];
    /** Set the witdth of the dialog screen */
    width: string;
    /** Set the height of the dialog screen */
    height: string;
    /** Set the title of the dialog */
    dialogTitle: string;
    /** Display a button which execute accept action */
    acceptButton: string;
    /** Display a button which execute cancel action */
    cancelButton: string;
    /** Display accept button as disabled */
    disableAcceptButton: boolean;
    /** Display a close button in the top right of the dialog */
    closeButton: boolean;
    /** A list of this dialog actions */
    actions: DialogAction[];
    /** The dialog body, it can be an HTMLElement or plain text */
    body: string | HTMLElement;
    bodySection: HTMLElement;
    componentDidLoad(): void;
    watchBody(): void;
    updateBody(): void;
    /**
     * @deprecated since 1.1.0 : use toggle() instead
     * Open/Close dialog.
     */
    show(): Promise<void>;
    /**
     * Open/close dialog
     */
    toggle(): Promise<void>;
    /**
     * Returns true if the dialog is open
     */
    isOpen(): Promise<boolean>;
    /**
     * Opens the dialog
     */
    open(): Promise<void>;
    /**
     * CloseS the dialog
     */
    close(): Promise<void>;
    getSectionClass(): {
        'mdc-dialog__content': boolean;
    };
    render(): any;
}
