import { EventEmitter } from '../../stencil-public-runtime';
export declare class ListItem {
    role: string;
    /**
     * Mark this item as disabled.
     */
    disabled: boolean;
    /**
     * Mark this item as selected.
     */
    selected: boolean;
    /**
     * make the item selectable
     */
    selectable: boolean;
    divider: boolean;
    itemStartStyle: any;
    itemEndStyle: any;
    noPadding: boolean;
    /**
     * Prefere le label au <slot /> pour beneficier du textWrap.
     */
    label: any;
    /**
     * Coupe le text par defaut.
     */
    textWrap: boolean;
    /**
     * override la height par defaut du composant list-item.
     */
    size: 'medium' | 'small';
    host: HTMLElement;
    /**
     * click of list-item handler
     */
    itemSelected: EventEmitter<void>;
    componentDidLoad(): void;
    private getClasses;
    setHeight(): {
        'height': string;
    };
    handleClick(): void;
    render(): any;
}
