'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-42b107ae.js');
require('./component-9b142814.js');
require('./ponyfill-32fd2054.js');
require('./component-3a63b4ac.js');
const component$2 = require('./component-490caf09.js');
const index$1 = require('./index-558a2b3e.js');

const TextArea = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.required = false;
        this.rows = 4;
        this.cols = 40;
        this.input = index.createEvent(this, "input", 7);
        this.change = index.createEvent(this, "change", 7);
    }
    updateValue() {
        if (this.mdcTextField) {
            this.mdcTextField.value = this.value;
        }
    }
    componentDidLoad() {
        this.mdcTextField = new index$1.MDCTextField(this.textFieldEl);
        component$2.MDCFloatingLabel.attachTo(this.floatingLabelEl);
        if (this.outlined) {
            component$2.MDCNotchedOutline.attachTo(this.notchedOutlineEl);
        }
    }
    getClasses() {
        return {
            'mdc-text-field': true,
            'mdc-text-field--textarea': true,
            'mdc-text-field--fullwidth': this.fullwidth,
            'mdc-text-field--disabled': this.disabled
        };
    }
    getLabelClasses() {
        return {
            'mdc-floating-label': true,
            'mdc-floating-label--float-above': !!this.value
        };
    }
    render() {
        return (index.h("div", { class: this.getClasses(), ref: mdcTextField => { this.textFieldEl = mdcTextField; } }, index.h("textarea", { id: "textarea", class: "mdc-text-field__input", rows: this.rows, cols: this.cols, value: this.value, required: this.required, onChange: (ev) => this.change.emit(ev), onInput: (ev) => {
                this.value = ev.target.value;
                this.input.emit(ev);
            } }), this.outlined ?
            index.h("div", { class: "mdc-notched-outline", ref: notchedOutlineEl => this.notchedOutlineEl = notchedOutlineEl }, index.h("div", { class: "mdc-notched-outline__leading" }), index.h("div", { class: "mdc-notched-outline__notch" }, index.h("label", { style: { 'background-color': 'transparent' }, htmlFor: "textarea", class: this.getLabelClasses(), ref: el => this.floatingLabelEl = el }, this.label)), index.h("div", { class: "mdc-notched-outline__trailing" }))
            : index.h("label", { style: { 'background-color': 'transparent' }, htmlFor: "textarea", class: this.getLabelClasses(), ref: el => this.floatingLabelEl = el }, this.label)));
    }
    static get watchers() { return {
        "value": ["updateValue"]
    }; }
    static get style() { return ":host{\@-webkit-keyframes mdc-floating-label-shake-float-above-standard{0%{-webkit-transform:translateX(calc(0 - 0%)) translateY(-50%) scale(0.75);transform:translateX(calc(0 - 0%)) translateY(-50%) scale(0.75);}33%{-webkit-animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);-webkit-transform:translateX(calc(4% - 0%)) translateY(-50%) scale(0.75);transform:translateX(calc(4% - 0%)) translateY(-50%) scale(0.75);}66%{-webkit-animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);-webkit-transform:translateX(calc(-4% - 0%)) translateY(-50%) scale(0.75);transform:translateX(calc(-4% - 0%)) translateY(-50%) scale(0.75);}100%{-webkit-transform:translateX(calc(0 - 0%)) translateY(-50%) scale(0.75);transform:translateX(calc(0 - 0%)) translateY(-50%) scale(0.75);}}\@keyframes mdc-floating-label-shake-float-above-standard{0%{-webkit-transform:translateX(calc(0 - 0%)) translateY(-50%) scale(0.75);transform:translateX(calc(0 - 0%)) translateY(-50%) scale(0.75);}33%{-webkit-animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);-webkit-transform:translateX(calc(4% - 0%)) translateY(-50%) scale(0.75);transform:translateX(calc(4% - 0%)) translateY(-50%) scale(0.75);}66%{-webkit-animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);-webkit-transform:translateX(calc(-4% - 0%)) translateY(-50%) scale(0.75);transform:translateX(calc(-4% - 0%)) translateY(-50%) scale(0.75);}100%{-webkit-transform:translateX(calc(0 - 0%)) translateY(-50%) scale(0.75);transform:translateX(calc(0 - 0%)) translateY(-50%) scale(0.75);}}\@-webkit-keyframes mdc-ripple-fg-radius-in{from{-webkit-animation-timing-function:cubic-bezier(0.4,0,0.2,1);animation-timing-function:cubic-bezier(0.4,0,0.2,1);-webkit-transform:translate(var(--mdc-ripple-fg-translate-start,0)) scale(1);transform:translate(var(--mdc-ripple-fg-translate-start,0)) scale(1);}to{-webkit-transform:translate(var(--mdc-ripple-fg-translate-end,0)) scale(var(--mdc-ripple-fg-scale,1));transform:translate(var(--mdc-ripple-fg-translate-end,0)) scale(var(--mdc-ripple-fg-scale,1));}}\@keyframes mdc-ripple-fg-radius-in{from{-webkit-animation-timing-function:cubic-bezier(0.4,0,0.2,1);animation-timing-function:cubic-bezier(0.4,0,0.2,1);-webkit-transform:translate(var(--mdc-ripple-fg-translate-start,0)) scale(1);transform:translate(var(--mdc-ripple-fg-translate-start,0)) scale(1);}to{-webkit-transform:translate(var(--mdc-ripple-fg-translate-end,0)) scale(var(--mdc-ripple-fg-scale,1));transform:translate(var(--mdc-ripple-fg-translate-end,0)) scale(var(--mdc-ripple-fg-scale,1));}}\@-webkit-keyframes mdc-ripple-fg-opacity-in{from{-webkit-animation-timing-function:linear;animation-timing-function:linear;opacity:0;}to{opacity:var(--mdc-ripple-fg-opacity,0);}}\@keyframes mdc-ripple-fg-opacity-in{from{-webkit-animation-timing-function:linear;animation-timing-function:linear;opacity:0;}to{opacity:var(--mdc-ripple-fg-opacity,0);}}\@-webkit-keyframes mdc-ripple-fg-opacity-out{from{-webkit-animation-timing-function:linear;animation-timing-function:linear;opacity:var(--mdc-ripple-fg-opacity,0);}to{opacity:0;}}\@keyframes mdc-ripple-fg-opacity-out{from{-webkit-animation-timing-function:linear;animation-timing-function:linear;opacity:var(--mdc-ripple-fg-opacity,0);}to{opacity:0;}}\@-webkit-keyframes mdc-floating-label-shake-float-above-text-field-dense{0%{-webkit-transform:translateX(calc(0 - 0%)) translateY(-70%) scale(0.8);transform:translateX(calc(0 - 0%)) translateY(-70%) scale(0.8);}33%{-webkit-animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);-webkit-transform:translateX(calc(4% - 0%)) translateY(-70%) scale(0.8);transform:translateX(calc(4% - 0%)) translateY(-70%) scale(0.8);}66%{-webkit-animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);-webkit-transform:translateX(calc(-4% - 0%)) translateY(-70%) scale(0.8);transform:translateX(calc(-4% - 0%)) translateY(-70%) scale(0.8);}100%{-webkit-transform:translateX(calc(0 - 0%)) translateY(-70%) scale(0.8);transform:translateX(calc(0 - 0%)) translateY(-70%) scale(0.8);}}\@keyframes mdc-floating-label-shake-float-above-text-field-dense{0%{-webkit-transform:translateX(calc(0 - 0%)) translateY(-70%) scale(0.8);transform:translateX(calc(0 - 0%)) translateY(-70%) scale(0.8);}33%{-webkit-animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);-webkit-transform:translateX(calc(4% - 0%)) translateY(-70%) scale(0.8);transform:translateX(calc(4% - 0%)) translateY(-70%) scale(0.8);}66%{-webkit-animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);-webkit-transform:translateX(calc(-4% - 0%)) translateY(-70%) scale(0.8);transform:translateX(calc(-4% - 0%)) translateY(-70%) scale(0.8);}100%{-webkit-transform:translateX(calc(0 - 0%)) translateY(-70%) scale(0.8);transform:translateX(calc(0 - 0%)) translateY(-70%) scale(0.8);}}\@-webkit-keyframes mdc-floating-label-shake-float-above-text-field-outlined{0%{-webkit-transform:translateX(calc(0 - 0%)) translateY(-130%) scale(0.75);transform:translateX(calc(0 - 0%)) translateY(-130%) scale(0.75);}33%{-webkit-animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);-webkit-transform:translateX(calc(4% - 0%)) translateY(-130%) scale(0.75);transform:translateX(calc(4% - 0%)) translateY(-130%) scale(0.75);}66%{-webkit-animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);-webkit-transform:translateX(calc(-4% - 0%)) translateY(-130%) scale(0.75);transform:translateX(calc(-4% - 0%)) translateY(-130%) scale(0.75);}100%{-webkit-transform:translateX(calc(0 - 0%)) translateY(-130%) scale(0.75);transform:translateX(calc(0 - 0%)) translateY(-130%) scale(0.75);}}\@keyframes mdc-floating-label-shake-float-above-text-field-outlined{0%{-webkit-transform:translateX(calc(0 - 0%)) translateY(-130%) scale(0.75);transform:translateX(calc(0 - 0%)) translateY(-130%) scale(0.75);}33%{-webkit-animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);-webkit-transform:translateX(calc(4% - 0%)) translateY(-130%) scale(0.75);transform:translateX(calc(4% - 0%)) translateY(-130%) scale(0.75);}66%{-webkit-animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);-webkit-transform:translateX(calc(-4% - 0%)) translateY(-130%) scale(0.75);transform:translateX(calc(-4% - 0%)) translateY(-130%) scale(0.75);}100%{-webkit-transform:translateX(calc(0 - 0%)) translateY(-130%) scale(0.75);transform:translateX(calc(0 - 0%)) translateY(-130%) scale(0.75);}}\@-webkit-keyframes mdc-floating-label-shake-float-above-text-field-outlined-dense{0%{-webkit-transform:translateX(calc(0 - 0%)) translateY(-120%) scale(0.8);transform:translateX(calc(0 - 0%)) translateY(-120%) scale(0.8);}33%{-webkit-animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);-webkit-transform:translateX(calc(4% - 0%)) translateY(-120%) scale(0.8);transform:translateX(calc(4% - 0%)) translateY(-120%) scale(0.8);}66%{-webkit-animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);-webkit-transform:translateX(calc(-4% - 0%)) translateY(-120%) scale(0.8);transform:translateX(calc(-4% - 0%)) translateY(-120%) scale(0.8);}100%{-webkit-transform:translateX(calc(0 - 0%)) translateY(-120%) scale(0.8);transform:translateX(calc(0 - 0%)) translateY(-120%) scale(0.8);}}\@keyframes mdc-floating-label-shake-float-above-text-field-outlined-dense{0%{-webkit-transform:translateX(calc(0 - 0%)) translateY(-120%) scale(0.8);transform:translateX(calc(0 - 0%)) translateY(-120%) scale(0.8);}33%{-webkit-animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);-webkit-transform:translateX(calc(4% - 0%)) translateY(-120%) scale(0.8);transform:translateX(calc(4% - 0%)) translateY(-120%) scale(0.8);}66%{-webkit-animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);-webkit-transform:translateX(calc(-4% - 0%)) translateY(-120%) scale(0.8);transform:translateX(calc(-4% - 0%)) translateY(-120%) scale(0.8);}100%{-webkit-transform:translateX(calc(0 - 0%)) translateY(-120%) scale(0.8);transform:translateX(calc(0 - 0%)) translateY(-120%) scale(0.8);}}\@-webkit-keyframes mdc-floating-label-shake-float-above-text-field-outlined-leading-icon{0%{-webkit-transform:translateX(calc(0 - 0)) translateY(-130%) scale(0.75);transform:translateX(calc(0 - 0)) translateY(-130%) scale(0.75);}33%{-webkit-animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);-webkit-transform:translateX(calc(4% - 0)) translateY(-130%) scale(0.75);transform:translateX(calc(4% - 0)) translateY(-130%) scale(0.75);}66%{-webkit-animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);-webkit-transform:translateX(calc(-4% - 0)) translateY(-130%) scale(0.75);transform:translateX(calc(-4% - 0)) translateY(-130%) scale(0.75);}100%{-webkit-transform:translateX(calc(0 - 0)) translateY(-130%) scale(0.75);transform:translateX(calc(0 - 0)) translateY(-130%) scale(0.75);}}\@keyframes mdc-floating-label-shake-float-above-text-field-outlined-leading-icon{0%{-webkit-transform:translateX(calc(0 - 0)) translateY(-130%) scale(0.75);transform:translateX(calc(0 - 0)) translateY(-130%) scale(0.75);}33%{-webkit-animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);-webkit-transform:translateX(calc(4% - 0)) translateY(-130%) scale(0.75);transform:translateX(calc(4% - 0)) translateY(-130%) scale(0.75);}66%{-webkit-animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);-webkit-transform:translateX(calc(-4% - 0)) translateY(-130%) scale(0.75);transform:translateX(calc(-4% - 0)) translateY(-130%) scale(0.75);}100%{-webkit-transform:translateX(calc(0 - 0)) translateY(-130%) scale(0.75);transform:translateX(calc(0 - 0)) translateY(-130%) scale(0.75);}}\@-webkit-keyframes mdc-floating-label-shake-float-above-text-field-outlined-leading-icon-dense{0%{-webkit-transform:translateX(calc(0 - 21px)) translateY(-120%) scale(0.8);transform:translateX(calc(0 - 21px)) translateY(-120%) scale(0.8);}33%{-webkit-animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);-webkit-transform:translateX(calc(4% - 21px)) translateY(-120%) scale(0.8);transform:translateX(calc(4% - 21px)) translateY(-120%) scale(0.8);}66%{-webkit-animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);-webkit-transform:translateX(calc(-4% - 21px)) translateY(-120%) scale(0.8);transform:translateX(calc(-4% - 21px)) translateY(-120%) scale(0.8);}100%{-webkit-transform:translateX(calc(0 - 21px)) translateY(-120%) scale(0.8);transform:translateX(calc(0 - 21px)) translateY(-120%) scale(0.8);}}\@keyframes mdc-floating-label-shake-float-above-text-field-outlined-leading-icon-dense{0%{-webkit-transform:translateX(calc(0 - 21px)) translateY(-120%) scale(0.8);transform:translateX(calc(0 - 21px)) translateY(-120%) scale(0.8);}33%{-webkit-animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);-webkit-transform:translateX(calc(4% - 21px)) translateY(-120%) scale(0.8);transform:translateX(calc(4% - 21px)) translateY(-120%) scale(0.8);}66%{-webkit-animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);-webkit-transform:translateX(calc(-4% - 21px)) translateY(-120%) scale(0.8);transform:translateX(calc(-4% - 21px)) translateY(-120%) scale(0.8);}100%{-webkit-transform:translateX(calc(0 - 21px)) translateY(-120%) scale(0.8);transform:translateX(calc(0 - 21px)) translateY(-120%) scale(0.8);}}\@-webkit-keyframes mdc-floating-label-shake-float-above-text-field-outlined-leading-icon-rtl{0%{-webkit-transform:translateX(calc(0 - 0)) translateY(-130%) scale(0.75);transform:translateX(calc(0 - 0)) translateY(-130%) scale(0.75);}33%{-webkit-animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);-webkit-transform:translateX(calc(4% - 0)) translateY(-130%) scale(0.75);transform:translateX(calc(4% - 0)) translateY(-130%) scale(0.75);}66%{-webkit-animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);-webkit-transform:translateX(calc(-4% - 0)) translateY(-130%) scale(0.75);transform:translateX(calc(-4% - 0)) translateY(-130%) scale(0.75);}100%{-webkit-transform:translateX(calc(0 - 0)) translateY(-130%) scale(0.75);transform:translateX(calc(0 - 0)) translateY(-130%) scale(0.75);}}\@keyframes mdc-floating-label-shake-float-above-text-field-outlined-leading-icon-rtl{0%{-webkit-transform:translateX(calc(0 - 0)) translateY(-130%) scale(0.75);transform:translateX(calc(0 - 0)) translateY(-130%) scale(0.75);}33%{-webkit-animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);-webkit-transform:translateX(calc(4% - 0)) translateY(-130%) scale(0.75);transform:translateX(calc(4% - 0)) translateY(-130%) scale(0.75);}66%{-webkit-animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);-webkit-transform:translateX(calc(-4% - 0)) translateY(-130%) scale(0.75);transform:translateX(calc(-4% - 0)) translateY(-130%) scale(0.75);}100%{-webkit-transform:translateX(calc(0 - 0)) translateY(-130%) scale(0.75);transform:translateX(calc(0 - 0)) translateY(-130%) scale(0.75);}}\@-webkit-keyframes mdc-floating-label-shake-float-above-text-field-outlined-leading-icon-dense-rtl{0%{-webkit-transform:translateX(calc(0 - -21px)) translateY(-120%) scale(0.8);transform:translateX(calc(0 - -21px)) translateY(-120%) scale(0.8);}33%{-webkit-animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);-webkit-transform:translateX(calc(4% - -21px)) translateY(-120%) scale(0.8);transform:translateX(calc(4% - -21px)) translateY(-120%) scale(0.8);}66%{-webkit-animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);-webkit-transform:translateX(calc(-4% - -21px)) translateY(-120%) scale(0.8);transform:translateX(calc(-4% - -21px)) translateY(-120%) scale(0.8);}100%{-webkit-transform:translateX(calc(0 - -21px)) translateY(-120%) scale(0.8);transform:translateX(calc(0 - -21px)) translateY(-120%) scale(0.8);}}\@keyframes mdc-floating-label-shake-float-above-text-field-outlined-leading-icon-dense-rtl{0%{-webkit-transform:translateX(calc(0 - -21px)) translateY(-120%) scale(0.8);transform:translateX(calc(0 - -21px)) translateY(-120%) scale(0.8);}33%{-webkit-animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);-webkit-transform:translateX(calc(4% - -21px)) translateY(-120%) scale(0.8);transform:translateX(calc(4% - -21px)) translateY(-120%) scale(0.8);}66%{-webkit-animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);-webkit-transform:translateX(calc(-4% - -21px)) translateY(-120%) scale(0.8);transform:translateX(calc(-4% - -21px)) translateY(-120%) scale(0.8);}100%{-webkit-transform:translateX(calc(0 - -21px)) translateY(-120%) scale(0.8);transform:translateX(calc(0 - -21px)) translateY(-120%) scale(0.8);}}\@-webkit-keyframes mdc-floating-label-shake-float-above-textarea{0%{-webkit-transform:translateX(calc(0 - 0%)) translateY(-130%) scale(0.75);transform:translateX(calc(0 - 0%)) translateY(-130%) scale(0.75);}33%{-webkit-animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);-webkit-transform:translateX(calc(4% - 0%)) translateY(-130%) scale(0.75);transform:translateX(calc(4% - 0%)) translateY(-130%) scale(0.75);}66%{-webkit-animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);-webkit-transform:translateX(calc(-4% - 0%)) translateY(-130%) scale(0.75);transform:translateX(calc(-4% - 0%)) translateY(-130%) scale(0.75);}100%{-webkit-transform:translateX(calc(0 - 0%)) translateY(-130%) scale(0.75);transform:translateX(calc(0 - 0%)) translateY(-130%) scale(0.75);}}\@keyframes mdc-floating-label-shake-float-above-textarea{0%{-webkit-transform:translateX(calc(0 - 0%)) translateY(-130%) scale(0.75);transform:translateX(calc(0 - 0%)) translateY(-130%) scale(0.75);}33%{-webkit-animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);animation-timing-function:cubic-bezier(0.5,0,0.701732,0.495819);-webkit-transform:translateX(calc(4% - 0%)) translateY(-130%) scale(0.75);transform:translateX(calc(4% - 0%)) translateY(-130%) scale(0.75);}66%{-webkit-animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);animation-timing-function:cubic-bezier(0.302435,0.381352,0.55,0.956352);-webkit-transform:translateX(calc(-4% - 0%)) translateY(-130%) scale(0.75);transform:translateX(calc(-4% - 0%)) translateY(-130%) scale(0.75);}100%{-webkit-transform:translateX(calc(0 - 0%)) translateY(-130%) scale(0.75);transform:translateX(calc(0 - 0%)) translateY(-130%) scale(0.75);}}}:host .mdc-floating-label{font-family:Roboto,sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;font-size:1rem;line-height:1.75rem;font-weight:400;letter-spacing:0.009375em;text-decoration:inherit;text-transform:inherit;position:absolute;left:0;-webkit-transform-origin:left top;transform-origin:left top;-webkit-transition:color 150ms cubic-bezier(0.4,0,0.2,1),-webkit-transform 150ms cubic-bezier(0.4,0,0.2,1);transition:color 150ms cubic-bezier(0.4,0,0.2,1),-webkit-transform 150ms cubic-bezier(0.4,0,0.2,1);transition:transform 150ms cubic-bezier(0.4,0,0.2,1),color 150ms cubic-bezier(0.4,0,0.2,1);transition:transform 150ms cubic-bezier(0.4,0,0.2,1),color 150ms cubic-bezier(0.4,0,0.2,1),-webkit-transform 150ms cubic-bezier(0.4,0,0.2,1);line-height:1.15rem;text-align:left;text-overflow:ellipsis;white-space:nowrap;cursor:text;overflow:hidden;will-change:transform;}[dir=rtl]:host .mdc-floating-label,:host .mdc-floating-label[dir=rtl]{right:0;left:auto;-webkit-transform-origin:right top;transform-origin:right top;text-align:right;}:host .mdc-floating-label--float-above{cursor:auto;}:host .mdc-floating-label--float-above{-webkit-transform:translateY(-50%) scale(0.75);transform:translateY(-50%) scale(0.75);}:host .mdc-floating-label--shake{-webkit-animation:mdc-floating-label-shake-float-above-standard 250ms 1;animation:mdc-floating-label-shake-float-above-standard 250ms 1;}:host .mdc-line-ripple{position:absolute;bottom:0;left:0;width:100%;height:2px;-webkit-transform:scaleX(0);transform:scaleX(0);-webkit-transition:opacity 180ms cubic-bezier(0.4,0,0.2,1),-webkit-transform 180ms cubic-bezier(0.4,0,0.2,1);transition:opacity 180ms cubic-bezier(0.4,0,0.2,1),-webkit-transform 180ms cubic-bezier(0.4,0,0.2,1);transition:transform 180ms cubic-bezier(0.4,0,0.2,1),opacity 180ms cubic-bezier(0.4,0,0.2,1);transition:transform 180ms cubic-bezier(0.4,0,0.2,1),opacity 180ms cubic-bezier(0.4,0,0.2,1),-webkit-transform 180ms cubic-bezier(0.4,0,0.2,1);opacity:0;z-index:2;}:host .mdc-line-ripple--active{-webkit-transform:scaleX(1);transform:scaleX(1);opacity:1;}:host .mdc-line-ripple--deactivating{opacity:0;}:host .mdc-notched-outline{display:-ms-flexbox;display:flex;position:absolute;right:0;left:0;-webkit-box-sizing:border-box;box-sizing:border-box;width:100%;max-width:100%;height:100%;text-align:left;pointer-events:none;}[dir=rtl]:host .mdc-notched-outline,:host .mdc-notched-outline[dir=rtl]{text-align:right;}:host .mdc-notched-outline__leading,:host .mdc-notched-outline__notch,:host .mdc-notched-outline__trailing{-webkit-box-sizing:border-box;box-sizing:border-box;height:100%;-webkit-transition:border 150ms cubic-bezier(0.4,0,0.2,1);transition:border 150ms cubic-bezier(0.4,0,0.2,1);border-top:1px solid;border-bottom:1px solid;pointer-events:none;}:host .mdc-notched-outline__leading{border-left:1px solid;border-right:none;width:12px;}[dir=rtl]:host .mdc-notched-outline__leading,:host .mdc-notched-outline__leading[dir=rtl]{border-left:none;border-right:1px solid;}:host .mdc-notched-outline__trailing{border-left:none;border-right:1px solid;-ms-flex-positive:1;flex-grow:1;}[dir=rtl]:host .mdc-notched-outline__trailing,:host .mdc-notched-outline__trailing[dir=rtl]{border-left:1px solid;border-right:none;}:host .mdc-notched-outline__notch{-ms-flex:0 0 auto;flex:0 0 auto;width:auto;max-width:calc(100% - 12px * 2);}:host .mdc-notched-outline .mdc-floating-label{display:inline-block;position:relative;top:17px;bottom:auto;max-width:100%;}:host .mdc-notched-outline .mdc-floating-label--float-above{text-overflow:clip;}:host .mdc-notched-outline--upgraded .mdc-floating-label--float-above{max-width:calc(100% / .75);}:host .mdc-notched-outline--notched .mdc-notched-outline__notch{padding-left:0;padding-right:8px;border-top:none;}[dir=rtl]:host .mdc-notched-outline--notched .mdc-notched-outline__notch,:host .mdc-notched-outline--notched .mdc-notched-outline__notch[dir=rtl]{padding-left:8px;padding-right:0;}:host .mdc-notched-outline--no-label .mdc-notched-outline__notch{padding:0;}:host .mdc-ripple-surface--test-edge-var-bug{--mdc-ripple-surface-test-edge-var:1px solid #000;visibility:hidden;}:host .mdc-ripple-surface--test-edge-var-bug::before{border:var(--mdc-ripple-surface-test-edge-var);}:host .mdc-text-field-helper-text{font-family:Roboto,sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;font-size:0.75rem;line-height:1.25rem;font-weight:400;letter-spacing:0.0333333333em;text-decoration:inherit;text-transform:inherit;display:block;margin-top:0;line-height:normal;margin:0;-webkit-transition:opacity 150ms cubic-bezier(0.4,0,0.2,1);transition:opacity 150ms cubic-bezier(0.4,0,0.2,1);opacity:0;will-change:opacity;}:host .mdc-text-field-helper-text::before{display:inline-block;width:0;height:16px;content:\"\";vertical-align:0;}:host .mdc-text-field-helper-text--persistent{-webkit-transition:none;transition:none;opacity:1;will-change:initial;}:host .mdc-text-field-character-counter{font-family:Roboto,sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;font-size:0.75rem;line-height:1.25rem;font-weight:400;letter-spacing:0.0333333333em;text-decoration:inherit;text-transform:inherit;display:block;margin-top:0;line-height:normal;margin-left:auto;margin-right:0;padding-left:16px;padding-right:0;white-space:nowrap;}:host .mdc-text-field-character-counter::before{display:inline-block;width:0;height:16px;content:\"\";vertical-align:0;}[dir=rtl]:host .mdc-text-field-character-counter,:host .mdc-text-field-character-counter[dir=rtl]{margin-left:0;margin-right:auto;}[dir=rtl]:host .mdc-text-field-character-counter,:host .mdc-text-field-character-counter[dir=rtl]{padding-left:0;padding-right:16px;}:host .mdc-text-field--with-leading-icon .mdc-text-field__icon,:host .mdc-text-field--with-trailing-icon .mdc-text-field__icon{position:absolute;bottom:16px;cursor:pointer;}:host .mdc-text-field__icon:not([tabindex]),:host .mdc-text-field__icon[tabindex=\"-1\"]{cursor:default;pointer-events:none;}:host .mdc-text-field{--mdc-ripple-fg-size:0;--mdc-ripple-left:0;--mdc-ripple-top:0;--mdc-ripple-fg-scale:1;--mdc-ripple-fg-translate-end:0;--mdc-ripple-fg-translate-start:0;-webkit-tap-highlight-color:rgba(0,0,0,0);border-radius:4px 4px 0 0;display:-ms-inline-flexbox;display:inline-flex;position:relative;-webkit-box-sizing:border-box;box-sizing:border-box;height:56px;overflow:hidden;will-change:opacity,transform,color;}:host .mdc-text-field::before,:host .mdc-text-field::after{position:absolute;border-radius:50%;opacity:0;pointer-events:none;content:\"\";}:host .mdc-text-field::before{-webkit-transition:opacity 15ms linear,background-color 15ms linear;transition:opacity 15ms linear,background-color 15ms linear;z-index:1;}:host .mdc-text-field.mdc-ripple-upgraded::before{-webkit-transform:scale(var(--mdc-ripple-fg-scale,1));transform:scale(var(--mdc-ripple-fg-scale,1));}:host .mdc-text-field.mdc-ripple-upgraded::after{top:0;left:0;-webkit-transform:scale(0);transform:scale(0);-webkit-transform-origin:center center;transform-origin:center center;}:host .mdc-text-field.mdc-ripple-upgraded--unbounded::after{top:var(--mdc-ripple-top,0);left:var(--mdc-ripple-left,0);}:host .mdc-text-field.mdc-ripple-upgraded--foreground-activation::after{-webkit-animation:mdc-ripple-fg-radius-in 225ms forwards,mdc-ripple-fg-opacity-in 75ms forwards;animation:mdc-ripple-fg-radius-in 225ms forwards,mdc-ripple-fg-opacity-in 75ms forwards;}:host .mdc-text-field.mdc-ripple-upgraded--foreground-deactivation::after{-webkit-animation:mdc-ripple-fg-opacity-out 150ms;animation:mdc-ripple-fg-opacity-out 150ms;-webkit-transform:translate(var(--mdc-ripple-fg-translate-end,0)) scale(var(--mdc-ripple-fg-scale,1));transform:translate(var(--mdc-ripple-fg-translate-end,0)) scale(var(--mdc-ripple-fg-scale,1));}:host .mdc-text-field::before,:host .mdc-text-field::after{background-color:rgba(0,0,0,0.87);}:host .mdc-text-field:hover::before{opacity:0.04;}:host .mdc-text-field:not(.mdc-ripple-upgraded):focus::before,:host .mdc-text-field.mdc-ripple-upgraded--background-focused::before{-webkit-transition-duration:75ms;transition-duration:75ms;opacity:0.12;}:host .mdc-text-field::before,:host .mdc-text-field::after{top:calc(50% - 100%);left:calc(50% - 100%);width:200%;height:200%;}:host .mdc-text-field.mdc-ripple-upgraded::after{width:var(--mdc-ripple-fg-size,100%);height:var(--mdc-ripple-fg-size,100%);}:host .mdc-text-field:not(.mdc-text-field--disabled) .mdc-floating-label{color:rgba(0,0,0,0.6);}:host .mdc-text-field:not(.mdc-text-field--disabled) .mdc-text-field__input{color:rgba(0,0,0,0.87);}:host .mdc-text-field .mdc-text-field__input{caret-color:#6200ee;caret-color:var(--mdc-theme-primary,#6200ee);}:host .mdc-text-field:not(.mdc-text-field--disabled):not(.mdc-text-field--outlined):not(.mdc-text-field--textarea) .mdc-text-field__input{border-bottom-color:rgba(0,0,0,0.42);}:host .mdc-text-field:not(.mdc-text-field--disabled):not(.mdc-text-field--outlined):not(.mdc-text-field--textarea) .mdc-text-field__input:hover{border-bottom-color:rgba(0,0,0,0.87);}:host .mdc-text-field .mdc-line-ripple{background-color:#6200ee;background-color:var(--mdc-theme-primary,#6200ee);}:host .mdc-text-field:not(.mdc-text-field--disabled):not(.mdc-text-field--textarea){border-bottom-color:rgba(0,0,0,0.12);}:host .mdc-text-field:not(.mdc-text-field--disabled)+.mdc-text-field-helper-line .mdc-text-field-helper-text{color:rgba(0,0,0,0.6);}:host .mdc-text-field:not(.mdc-text-field--disabled) .mdc-text-field-character-counter,:host .mdc-text-field:not(.mdc-text-field--disabled)+.mdc-text-field-helper-line .mdc-text-field-character-counter{color:rgba(0,0,0,0.6);}:host .mdc-text-field:not(.mdc-text-field--disabled) .mdc-text-field__icon{color:rgba(0,0,0,0.54);}:host .mdc-text-field:not(.mdc-text-field--disabled){background-color:whitesmoke;}:host .mdc-text-field .mdc-floating-label{left:16px;right:initial;top:18px;pointer-events:none;}[dir=rtl]:host .mdc-text-field .mdc-floating-label,:host .mdc-text-field .mdc-floating-label[dir=rtl]{left:initial;right:16px;}:host .mdc-text-field--textarea .mdc-floating-label{left:4px;right:initial;}[dir=rtl]:host .mdc-text-field--textarea .mdc-floating-label,:host .mdc-text-field--textarea .mdc-floating-label[dir=rtl]{left:initial;right:4px;}:host .mdc-text-field--outlined .mdc-floating-label{left:4px;right:initial;top:17px;}[dir=rtl]:host .mdc-text-field--outlined .mdc-floating-label,:host .mdc-text-field--outlined .mdc-floating-label[dir=rtl]{left:initial;right:4px;}:host .mdc-text-field--outlined--with-leading-icon .mdc-floating-label{left:36px;right:initial;}[dir=rtl]:host .mdc-text-field--outlined--with-leading-icon .mdc-floating-label,:host .mdc-text-field--outlined--with-leading-icon .mdc-floating-label[dir=rtl]{left:initial;right:36px;}:host .mdc-text-field--outlined--with-leading-icon .mdc-floating-label--float-above{left:40px;right:initial;}[dir=rtl]:host .mdc-text-field--outlined--with-leading-icon .mdc-floating-label--float-above,:host .mdc-text-field--outlined--with-leading-icon .mdc-floating-label--float-above[dir=rtl]{left:initial;right:40px;}:host .mdc-text-field__input{font-family:Roboto,sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;font-size:1rem;line-height:1.75rem;font-weight:400;letter-spacing:0.009375em;text-decoration:inherit;text-transform:inherit;-ms-flex-item-align:end;align-self:flex-end;-webkit-box-sizing:border-box;box-sizing:border-box;width:100%;height:100%;padding:20px 16px 6px;-webkit-transition:opacity 150ms cubic-bezier(0.4,0,0.2,1);transition:opacity 150ms cubic-bezier(0.4,0,0.2,1);border:none;border-bottom:1px solid;border-radius:0;background:none;-webkit-appearance:none;-moz-appearance:none;appearance:none;}:host .mdc-text-field__input::-webkit-input-placeholder{-webkit-transition:opacity 67ms cubic-bezier(0.4,0,0.2,1);transition:opacity 67ms cubic-bezier(0.4,0,0.2,1);opacity:0;color:rgba(0,0,0,0.54);}:host .mdc-text-field__input::-moz-placeholder{-moz-transition:opacity 67ms cubic-bezier(0.4,0,0.2,1);transition:opacity 67ms cubic-bezier(0.4,0,0.2,1);opacity:0;color:rgba(0,0,0,0.54);}:host .mdc-text-field__input:-ms-input-placeholder{-ms-transition:opacity 67ms cubic-bezier(0.4,0,0.2,1);transition:opacity 67ms cubic-bezier(0.4,0,0.2,1);opacity:0;color:rgba(0,0,0,0.54);}:host .mdc-text-field__input::-ms-input-placeholder{-ms-transition:opacity 67ms cubic-bezier(0.4,0,0.2,1);transition:opacity 67ms cubic-bezier(0.4,0,0.2,1);opacity:0;color:rgba(0,0,0,0.54);}:host .mdc-text-field__input::placeholder{-webkit-transition:opacity 67ms cubic-bezier(0.4,0,0.2,1);transition:opacity 67ms cubic-bezier(0.4,0,0.2,1);opacity:0;color:rgba(0,0,0,0.54);}:host .mdc-text-field__input:-ms-input-placeholder{color:rgba(0,0,0,0.54) !important;}.mdc-text-field--fullwidth:host .mdc-text-field__input::-webkit-input-placeholder,.mdc-text-field--no-label:host .mdc-text-field__input::-webkit-input-placeholder,.mdc-text-field--focused:host .mdc-text-field__input::-webkit-input-placeholder{-webkit-transition-delay:40ms;transition-delay:40ms;-webkit-transition-duration:110ms;transition-duration:110ms;opacity:1;}.mdc-text-field--fullwidth:host .mdc-text-field__input::-moz-placeholder,.mdc-text-field--no-label:host .mdc-text-field__input::-moz-placeholder,.mdc-text-field--focused:host .mdc-text-field__input::-moz-placeholder{transition-delay:40ms;transition-duration:110ms;opacity:1;}.mdc-text-field--fullwidth:host .mdc-text-field__input:-ms-input-placeholder,.mdc-text-field--no-label:host .mdc-text-field__input:-ms-input-placeholder,.mdc-text-field--focused:host .mdc-text-field__input:-ms-input-placeholder{transition-delay:40ms;transition-duration:110ms;opacity:1;}.mdc-text-field--fullwidth:host .mdc-text-field__input::-ms-input-placeholder,.mdc-text-field--no-label:host .mdc-text-field__input::-ms-input-placeholder,.mdc-text-field--focused:host .mdc-text-field__input::-ms-input-placeholder{transition-delay:40ms;transition-duration:110ms;opacity:1;}.mdc-text-field--fullwidth:host .mdc-text-field__input::placeholder,.mdc-text-field--no-label:host .mdc-text-field__input::placeholder,.mdc-text-field--focused:host .mdc-text-field__input::placeholder{-webkit-transition-delay:40ms;transition-delay:40ms;-webkit-transition-duration:110ms;transition-duration:110ms;opacity:1;}:host .mdc-text-field__input:focus{outline:none;}:host .mdc-text-field__input:invalid{-webkit-box-shadow:none;box-shadow:none;}:host .mdc-text-field__input:-webkit-autofill{z-index:auto !important;}.mdc-text-field--no-label:not(.mdc-text-field--outlined):not(.mdc-text-field--textarea):host .mdc-text-field__input{padding-top:16px;padding-bottom:16px;}:host .mdc-text-field__input:-webkit-autofill+.mdc-floating-label{-webkit-transform:translateY(-50%) scale(0.75);transform:translateY(-50%) scale(0.75);cursor:auto;}:host .mdc-text-field--outlined{border:none;overflow:visible;}:host .mdc-text-field--outlined:not(.mdc-text-field--disabled) .mdc-notched-outline__leading,:host .mdc-text-field--outlined:not(.mdc-text-field--disabled) .mdc-notched-outline__notch,:host .mdc-text-field--outlined:not(.mdc-text-field--disabled) .mdc-notched-outline__trailing{border-color:rgba(0,0,0,0.24);}:host .mdc-text-field--outlined:not(.mdc-text-field--disabled):not(.mdc-text-field--focused) .mdc-text-field__input:hover ~ .mdc-notched-outline .mdc-notched-outline__leading,:host .mdc-text-field--outlined:not(.mdc-text-field--disabled):not(.mdc-text-field--focused) .mdc-text-field__input:hover ~ .mdc-notched-outline .mdc-notched-outline__notch,:host .mdc-text-field--outlined:not(.mdc-text-field--disabled):not(.mdc-text-field--focused) .mdc-text-field__input:hover ~ .mdc-notched-outline .mdc-notched-outline__trailing,:host .mdc-text-field--outlined:not(.mdc-text-field--disabled):not(.mdc-text-field--focused) .mdc-text-field__icon:hover ~ .mdc-notched-outline .mdc-notched-outline__leading,:host .mdc-text-field--outlined:not(.mdc-text-field--disabled):not(.mdc-text-field--focused) .mdc-text-field__icon:hover ~ .mdc-notched-outline .mdc-notched-outline__notch,:host .mdc-text-field--outlined:not(.mdc-text-field--disabled):not(.mdc-text-field--focused) .mdc-text-field__icon:hover ~ .mdc-notched-outline .mdc-notched-outline__trailing{border-color:rgba(0,0,0,0.87);}:host .mdc-text-field--outlined:not(.mdc-text-field--disabled).mdc-text-field--focused .mdc-notched-outline__leading,:host .mdc-text-field--outlined:not(.mdc-text-field--disabled).mdc-text-field--focused .mdc-notched-outline__notch,:host .mdc-text-field--outlined:not(.mdc-text-field--disabled).mdc-text-field--focused .mdc-notched-outline__trailing{border-color:#6200ee;border-color:var(--mdc-theme-primary,#6200ee);}:host .mdc-text-field--outlined .mdc-floating-label--shake{-webkit-animation:mdc-floating-label-shake-float-above-text-field-outlined 250ms 1;animation:mdc-floating-label-shake-float-above-text-field-outlined 250ms 1;}:host .mdc-text-field--outlined .mdc-notched-outline .mdc-notched-outline__leading{border-radius:4px 0 0 4px;}[dir=rtl]:host .mdc-text-field--outlined .mdc-notched-outline .mdc-notched-outline__leading,:host .mdc-text-field--outlined .mdc-notched-outline .mdc-notched-outline__leading[dir=rtl]{border-radius:0 4px 4px 0;}:host .mdc-text-field--outlined .mdc-notched-outline .mdc-notched-outline__trailing{border-radius:0 4px 4px 0;}[dir=rtl]:host .mdc-text-field--outlined .mdc-notched-outline .mdc-notched-outline__trailing,:host .mdc-text-field--outlined .mdc-notched-outline .mdc-notched-outline__trailing[dir=rtl]{border-radius:4px 0 0 4px;}:host .mdc-text-field--outlined .mdc-floating-label--float-above{-webkit-transform:translateY(-144%) scale(1);transform:translateY(-144%) scale(1);}:host .mdc-text-field--outlined .mdc-floating-label--float-above{font-size:0.75rem;}:host .mdc-text-field--outlined.mdc-notched-outline--upgraded .mdc-floating-label--float-above,:host .mdc-text-field--outlined .mdc-notched-outline--upgraded .mdc-floating-label--float-above{-webkit-transform:translateY(-130%) scale(0.75);transform:translateY(-130%) scale(0.75);}:host .mdc-text-field--outlined.mdc-notched-outline--upgraded .mdc-floating-label--float-above,:host .mdc-text-field--outlined .mdc-notched-outline--upgraded .mdc-floating-label--float-above{font-size:1rem;}:host .mdc-text-field--outlined::before,:host .mdc-text-field--outlined::after{content:none;}:host .mdc-text-field--outlined:not(.mdc-text-field--disabled){background-color:transparent;}:host .mdc-text-field--outlined .mdc-text-field__input{display:-ms-flexbox;display:flex;padding:12px 16px 14px;border:none !important;background-color:transparent;z-index:1;}:host .mdc-text-field--outlined .mdc-text-field__icon{z-index:2;}:host .mdc-text-field--outlined.mdc-text-field--focused .mdc-notched-outline__leading,:host .mdc-text-field--outlined.mdc-text-field--focused .mdc-notched-outline__notch,:host .mdc-text-field--outlined.mdc-text-field--focused .mdc-notched-outline__trailing{border-width:2px;}:host .mdc-text-field--outlined.mdc-text-field--disabled{background-color:transparent;}:host .mdc-text-field--outlined.mdc-text-field--disabled .mdc-notched-outline__leading,:host .mdc-text-field--outlined.mdc-text-field--disabled .mdc-notched-outline__notch,:host .mdc-text-field--outlined.mdc-text-field--disabled .mdc-notched-outline__trailing{border-color:rgba(0,0,0,0.06);}:host .mdc-text-field--outlined.mdc-text-field--disabled .mdc-text-field__input{border-bottom:none;}:host .mdc-text-field--outlined.mdc-text-field--dense{height:48px;}:host .mdc-text-field--outlined.mdc-text-field--dense .mdc-floating-label--float-above{-webkit-transform:translateY(-134%) scale(1);transform:translateY(-134%) scale(1);}:host .mdc-text-field--outlined.mdc-text-field--dense .mdc-floating-label--float-above{font-size:0.8rem;}:host .mdc-text-field--outlined.mdc-text-field--dense.mdc-notched-outline--upgraded .mdc-floating-label--float-above,:host .mdc-text-field--outlined.mdc-text-field--dense .mdc-notched-outline--upgraded .mdc-floating-label--float-above{-webkit-transform:translateY(-120%) scale(0.8);transform:translateY(-120%) scale(0.8);}:host .mdc-text-field--outlined.mdc-text-field--dense.mdc-notched-outline--upgraded .mdc-floating-label--float-above,:host .mdc-text-field--outlined.mdc-text-field--dense .mdc-notched-outline--upgraded .mdc-floating-label--float-above{font-size:1rem;}:host .mdc-text-field--outlined.mdc-text-field--dense .mdc-floating-label--shake{-webkit-animation:mdc-floating-label-shake-float-above-text-field-outlined-dense 250ms 1;animation:mdc-floating-label-shake-float-above-text-field-outlined-dense 250ms 1;}:host .mdc-text-field--outlined.mdc-text-field--dense .mdc-text-field__input{padding:12px 12px 7px;}:host .mdc-text-field--outlined.mdc-text-field--dense .mdc-floating-label{top:14px;}:host .mdc-text-field--outlined.mdc-text-field--dense .mdc-text-field__icon{top:12px;}:host .mdc-text-field--with-leading-icon .mdc-text-field__icon{left:16px;right:initial;}[dir=rtl]:host .mdc-text-field--with-leading-icon .mdc-text-field__icon,:host .mdc-text-field--with-leading-icon .mdc-text-field__icon[dir=rtl]{left:initial;right:16px;}:host .mdc-text-field--with-leading-icon .mdc-text-field__input{padding-left:48px;padding-right:16px;}[dir=rtl]:host .mdc-text-field--with-leading-icon .mdc-text-field__input,:host .mdc-text-field--with-leading-icon .mdc-text-field__input[dir=rtl]{padding-left:16px;padding-right:48px;}:host .mdc-text-field--with-leading-icon .mdc-floating-label{left:48px;right:initial;}[dir=rtl]:host .mdc-text-field--with-leading-icon .mdc-floating-label,:host .mdc-text-field--with-leading-icon .mdc-floating-label[dir=rtl]{left:initial;right:48px;}:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined .mdc-text-field__icon{left:16px;right:initial;}[dir=rtl]:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined .mdc-text-field__icon,:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined .mdc-text-field__icon[dir=rtl]{left:initial;right:16px;}:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined .mdc-text-field__input{padding-left:48px;padding-right:16px;}[dir=rtl]:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined .mdc-text-field__input,:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined .mdc-text-field__input[dir=rtl]{padding-left:16px;padding-right:48px;}:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined .mdc-floating-label--float-above{-webkit-transform:translateY(-144%) translateX(-32px) scale(1);transform:translateY(-144%) translateX(-32px) scale(1);}[dir=rtl]:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined .mdc-floating-label--float-above,:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined .mdc-floating-label--float-above[dir=rtl]{-webkit-transform:translateY(-144%) translateX(32px) scale(1);transform:translateY(-144%) translateX(32px) scale(1);}:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined .mdc-floating-label--float-above{font-size:0.75rem;}:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined.mdc-notched-outline--upgraded .mdc-floating-label--float-above,:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined .mdc-notched-outline--upgraded .mdc-floating-label--float-above{-webkit-transform:translateY(-130%) translateX(-32px) scale(0.75);transform:translateY(-130%) translateX(-32px) scale(0.75);}[dir=rtl]:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined.mdc-notched-outline--upgraded .mdc-floating-label--float-above,:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined.mdc-notched-outline--upgraded .mdc-floating-label--float-above[dir=rtl],[dir=rtl]:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined .mdc-notched-outline--upgraded .mdc-floating-label--float-above,:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined .mdc-notched-outline--upgraded .mdc-floating-label--float-above[dir=rtl]{-webkit-transform:translateY(-130%) translateX(32px) scale(0.75);transform:translateY(-130%) translateX(32px) scale(0.75);}:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined.mdc-notched-outline--upgraded .mdc-floating-label--float-above,:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined .mdc-notched-outline--upgraded .mdc-floating-label--float-above{font-size:1rem;}:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined .mdc-floating-label--shake{-webkit-animation:mdc-floating-label-shake-float-above-text-field-outlined-leading-icon 250ms 1;animation:mdc-floating-label-shake-float-above-text-field-outlined-leading-icon 250ms 1;}[dir=rtl]:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined .mdc-floating-label--shake,:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined[dir=rtl] .mdc-floating-label--shake{-webkit-animation:mdc-floating-label-shake-float-above-text-field-outlined-leading-icon-rtl 250ms 1;animation:mdc-floating-label-shake-float-above-text-field-outlined-leading-icon-rtl 250ms 1;}:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined .mdc-floating-label{left:36px;right:initial;}[dir=rtl]:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined .mdc-floating-label,:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined .mdc-floating-label[dir=rtl]{left:initial;right:36px;}:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined.mdc-text-field--dense .mdc-floating-label--float-above{-webkit-transform:translateY(-134%) translateX(-21px) scale(1);transform:translateY(-134%) translateX(-21px) scale(1);}[dir=rtl]:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined.mdc-text-field--dense .mdc-floating-label--float-above,:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined.mdc-text-field--dense .mdc-floating-label--float-above[dir=rtl]{-webkit-transform:translateY(-134%) translateX(21px) scale(1);transform:translateY(-134%) translateX(21px) scale(1);}:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined.mdc-text-field--dense .mdc-floating-label--float-above{font-size:0.8rem;}:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined.mdc-text-field--dense.mdc-notched-outline--upgraded .mdc-floating-label--float-above,:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined.mdc-text-field--dense .mdc-notched-outline--upgraded .mdc-floating-label--float-above{-webkit-transform:translateY(-120%) translateX(-21px) scale(0.8);transform:translateY(-120%) translateX(-21px) scale(0.8);}[dir=rtl]:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined.mdc-text-field--dense.mdc-notched-outline--upgraded .mdc-floating-label--float-above,:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined.mdc-text-field--dense.mdc-notched-outline--upgraded .mdc-floating-label--float-above[dir=rtl],[dir=rtl]:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined.mdc-text-field--dense .mdc-notched-outline--upgraded .mdc-floating-label--float-above,:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined.mdc-text-field--dense .mdc-notched-outline--upgraded .mdc-floating-label--float-above[dir=rtl]{-webkit-transform:translateY(-120%) translateX(21px) scale(0.8);transform:translateY(-120%) translateX(21px) scale(0.8);}:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined.mdc-text-field--dense.mdc-notched-outline--upgraded .mdc-floating-label--float-above,:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined.mdc-text-field--dense .mdc-notched-outline--upgraded .mdc-floating-label--float-above{font-size:1rem;}:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined.mdc-text-field--dense .mdc-floating-label--shake{-webkit-animation:mdc-floating-label-shake-float-above-text-field-outlined-leading-icon-dense 250ms 1;animation:mdc-floating-label-shake-float-above-text-field-outlined-leading-icon-dense 250ms 1;}[dir=rtl]:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined.mdc-text-field--dense .mdc-floating-label--shake,:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined.mdc-text-field--dense[dir=rtl] .mdc-floating-label--shake{-webkit-animation:mdc-floating-label-shake-float-above-text-field-outlined-leading-icon-dense-rtl 250ms 1;animation:mdc-floating-label-shake-float-above-text-field-outlined-leading-icon-dense-rtl 250ms 1;}:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined.mdc-text-field--dense .mdc-floating-label{left:32px;right:initial;}[dir=rtl]:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined.mdc-text-field--dense .mdc-floating-label,:host .mdc-text-field--with-leading-icon.mdc-text-field--outlined.mdc-text-field--dense .mdc-floating-label[dir=rtl]{left:initial;right:32px;}:host .mdc-text-field--with-trailing-icon .mdc-text-field__icon{left:initial;right:12px;}[dir=rtl]:host .mdc-text-field--with-trailing-icon .mdc-text-field__icon,:host .mdc-text-field--with-trailing-icon .mdc-text-field__icon[dir=rtl]{left:12px;right:initial;}:host .mdc-text-field--with-trailing-icon .mdc-text-field__input{padding-left:16px;padding-right:48px;}[dir=rtl]:host .mdc-text-field--with-trailing-icon .mdc-text-field__input,:host .mdc-text-field--with-trailing-icon .mdc-text-field__input[dir=rtl]{padding-left:48px;padding-right:16px;}:host .mdc-text-field--with-trailing-icon.mdc-text-field--outlined .mdc-text-field__icon{left:initial;right:16px;}[dir=rtl]:host .mdc-text-field--with-trailing-icon.mdc-text-field--outlined .mdc-text-field__icon,:host .mdc-text-field--with-trailing-icon.mdc-text-field--outlined .mdc-text-field__icon[dir=rtl]{left:16px;right:initial;}:host .mdc-text-field--with-trailing-icon.mdc-text-field--outlined .mdc-text-field__input{padding-left:16px;padding-right:48px;}[dir=rtl]:host .mdc-text-field--with-trailing-icon.mdc-text-field--outlined .mdc-text-field__input,:host .mdc-text-field--with-trailing-icon.mdc-text-field--outlined .mdc-text-field__input[dir=rtl]{padding-left:48px;padding-right:16px;}:host .mdc-text-field--with-leading-icon.mdc-text-field--with-trailing-icon .mdc-text-field__icon{left:16px;right:auto;}[dir=rtl]:host .mdc-text-field--with-leading-icon.mdc-text-field--with-trailing-icon .mdc-text-field__icon,:host .mdc-text-field--with-leading-icon.mdc-text-field--with-trailing-icon .mdc-text-field__icon[dir=rtl]{left:auto;right:16px;}:host .mdc-text-field--with-leading-icon.mdc-text-field--with-trailing-icon .mdc-text-field__icon ~ .mdc-text-field__icon{right:12px;left:auto;}[dir=rtl]:host .mdc-text-field--with-leading-icon.mdc-text-field--with-trailing-icon .mdc-text-field__icon ~ .mdc-text-field__icon,:host .mdc-text-field--with-leading-icon.mdc-text-field--with-trailing-icon .mdc-text-field__icon ~ .mdc-text-field__icon[dir=rtl]{right:auto;left:12px;}:host .mdc-text-field--with-leading-icon.mdc-text-field--with-trailing-icon .mdc-text-field__input{padding-left:48px;padding-right:48px;}[dir=rtl]:host .mdc-text-field--with-leading-icon.mdc-text-field--with-trailing-icon .mdc-text-field__input,:host .mdc-text-field--with-leading-icon.mdc-text-field--with-trailing-icon .mdc-text-field__input[dir=rtl]{padding-left:48px;padding-right:48px;}:host .mdc-text-field--with-leading-icon.mdc-text-field--dense .mdc-text-field__icon,:host .mdc-text-field--with-trailing-icon.mdc-text-field--dense .mdc-text-field__icon{bottom:16px;-webkit-transform:scale(0.8);transform:scale(0.8);}:host .mdc-text-field--with-leading-icon.mdc-text-field--dense .mdc-text-field__icon{left:12px;right:initial;}[dir=rtl]:host .mdc-text-field--with-leading-icon.mdc-text-field--dense .mdc-text-field__icon,:host .mdc-text-field--with-leading-icon.mdc-text-field--dense .mdc-text-field__icon[dir=rtl]{left:initial;right:12px;}:host .mdc-text-field--with-leading-icon.mdc-text-field--dense .mdc-text-field__input{padding-left:44px;padding-right:16px;}[dir=rtl]:host .mdc-text-field--with-leading-icon.mdc-text-field--dense .mdc-text-field__input,:host .mdc-text-field--with-leading-icon.mdc-text-field--dense .mdc-text-field__input[dir=rtl]{padding-left:16px;padding-right:44px;}:host .mdc-text-field--with-leading-icon.mdc-text-field--dense .mdc-floating-label{left:44px;right:initial;}[dir=rtl]:host .mdc-text-field--with-leading-icon.mdc-text-field--dense .mdc-floating-label,:host .mdc-text-field--with-leading-icon.mdc-text-field--dense .mdc-floating-label[dir=rtl]{left:initial;right:44px;}:host .mdc-text-field--with-trailing-icon.mdc-text-field--dense .mdc-text-field__icon{left:initial;right:12px;}[dir=rtl]:host .mdc-text-field--with-trailing-icon.mdc-text-field--dense .mdc-text-field__icon,:host .mdc-text-field--with-trailing-icon.mdc-text-field--dense .mdc-text-field__icon[dir=rtl]{left:12px;right:initial;}:host .mdc-text-field--with-trailing-icon.mdc-text-field--dense .mdc-text-field__input{padding-left:16px;padding-right:44px;}[dir=rtl]:host .mdc-text-field--with-trailing-icon.mdc-text-field--dense .mdc-text-field__input,:host .mdc-text-field--with-trailing-icon.mdc-text-field--dense .mdc-text-field__input[dir=rtl]{padding-left:44px;padding-right:16px;}:host .mdc-text-field--with-leading-icon.mdc-text-field--with-trailing-icon.mdc-text-field--dense .mdc-text-field__icon{left:12px;right:auto;}[dir=rtl]:host .mdc-text-field--with-leading-icon.mdc-text-field--with-trailing-icon.mdc-text-field--dense .mdc-text-field__icon,:host .mdc-text-field--with-leading-icon.mdc-text-field--with-trailing-icon.mdc-text-field--dense .mdc-text-field__icon[dir=rtl]{left:auto;right:12px;}:host .mdc-text-field--with-leading-icon.mdc-text-field--with-trailing-icon.mdc-text-field--dense .mdc-text-field__icon ~ .mdc-text-field__icon{right:12px;left:auto;}[dir=rtl]:host .mdc-text-field--with-leading-icon.mdc-text-field--with-trailing-icon.mdc-text-field--dense .mdc-text-field__icon ~ .mdc-text-field__icon,:host .mdc-text-field--with-leading-icon.mdc-text-field--with-trailing-icon.mdc-text-field--dense .mdc-text-field__icon ~ .mdc-text-field__icon[dir=rtl]{right:auto;left:12px;}:host .mdc-text-field--with-leading-icon.mdc-text-field--with-trailing-icon.mdc-text-field--dense .mdc-text-field__input{padding-left:44px;padding-right:44px;}[dir=rtl]:host .mdc-text-field--with-leading-icon.mdc-text-field--with-trailing-icon.mdc-text-field--dense .mdc-text-field__input,:host .mdc-text-field--with-leading-icon.mdc-text-field--with-trailing-icon.mdc-text-field--dense .mdc-text-field__input[dir=rtl]{padding-left:44px;padding-right:44px;}:host .mdc-text-field--dense .mdc-floating-label--float-above{-webkit-transform:translateY(-70%) scale(0.8);transform:translateY(-70%) scale(0.8);}:host .mdc-text-field--dense .mdc-floating-label--shake{-webkit-animation:mdc-floating-label-shake-float-above-text-field-dense 250ms 1;animation:mdc-floating-label-shake-float-above-text-field-dense 250ms 1;}:host .mdc-text-field--dense .mdc-text-field__input{padding:12px 12px 0;}:host .mdc-text-field--dense .mdc-floating-label{font-size:0.813rem;}:host .mdc-text-field--dense .mdc-floating-label--float-above{font-size:0.813rem;}:host .mdc-text-field__input:required ~ .mdc-floating-label::after,:host .mdc-text-field__input:required ~ .mdc-notched-outline .mdc-floating-label::after{margin-left:1px;content:\"*\";}:host .mdc-text-field--textarea{display:-ms-inline-flexbox;display:inline-flex;width:auto;height:auto;-webkit-transition:none;transition:none;overflow:visible;}:host .mdc-text-field--textarea:not(.mdc-text-field--disabled) .mdc-notched-outline__leading,:host .mdc-text-field--textarea:not(.mdc-text-field--disabled) .mdc-notched-outline__notch,:host .mdc-text-field--textarea:not(.mdc-text-field--disabled) .mdc-notched-outline__trailing{border-color:rgba(0,0,0,0.24);}:host .mdc-text-field--textarea:not(.mdc-text-field--disabled):not(.mdc-text-field--focused) .mdc-text-field__input:hover ~ .mdc-notched-outline .mdc-notched-outline__leading,:host .mdc-text-field--textarea:not(.mdc-text-field--disabled):not(.mdc-text-field--focused) .mdc-text-field__input:hover ~ .mdc-notched-outline .mdc-notched-outline__notch,:host .mdc-text-field--textarea:not(.mdc-text-field--disabled):not(.mdc-text-field--focused) .mdc-text-field__input:hover ~ .mdc-notched-outline .mdc-notched-outline__trailing,:host .mdc-text-field--textarea:not(.mdc-text-field--disabled):not(.mdc-text-field--focused) .mdc-text-field__icon:hover ~ .mdc-notched-outline .mdc-notched-outline__leading,:host .mdc-text-field--textarea:not(.mdc-text-field--disabled):not(.mdc-text-field--focused) .mdc-text-field__icon:hover ~ .mdc-notched-outline .mdc-notched-outline__notch,:host .mdc-text-field--textarea:not(.mdc-text-field--disabled):not(.mdc-text-field--focused) .mdc-text-field__icon:hover ~ .mdc-notched-outline .mdc-notched-outline__trailing{border-color:rgba(0,0,0,0.87);}:host .mdc-text-field--textarea:not(.mdc-text-field--disabled).mdc-text-field--focused .mdc-notched-outline__leading,:host .mdc-text-field--textarea:not(.mdc-text-field--disabled).mdc-text-field--focused .mdc-notched-outline__notch,:host .mdc-text-field--textarea:not(.mdc-text-field--disabled).mdc-text-field--focused .mdc-notched-outline__trailing{border-color:#6200ee;border-color:var(--mdc-theme-primary,#6200ee);}:host .mdc-text-field--textarea .mdc-floating-label--shake{-webkit-animation:mdc-floating-label-shake-float-above-text-field-outlined 250ms 1;animation:mdc-floating-label-shake-float-above-text-field-outlined 250ms 1;}:host .mdc-text-field--textarea .mdc-notched-outline .mdc-notched-outline__leading{border-radius:4px 0 0 4px;}[dir=rtl]:host .mdc-text-field--textarea .mdc-notched-outline .mdc-notched-outline__leading,:host .mdc-text-field--textarea .mdc-notched-outline .mdc-notched-outline__leading[dir=rtl]{border-radius:0 4px 4px 0;}:host .mdc-text-field--textarea .mdc-notched-outline .mdc-notched-outline__trailing{border-radius:0 4px 4px 0;}[dir=rtl]:host .mdc-text-field--textarea .mdc-notched-outline .mdc-notched-outline__trailing,:host .mdc-text-field--textarea .mdc-notched-outline .mdc-notched-outline__trailing[dir=rtl]{border-radius:4px 0 0 4px;}:host .mdc-text-field--textarea::before,:host .mdc-text-field--textarea::after{content:none;}:host .mdc-text-field--textarea:not(.mdc-text-field--disabled){background-color:transparent;}:host .mdc-text-field--textarea .mdc-floating-label--float-above{-webkit-transform:translateY(-144%) scale(1);transform:translateY(-144%) scale(1);}:host .mdc-text-field--textarea .mdc-floating-label--float-above{font-size:0.75rem;}:host .mdc-text-field--textarea.mdc-notched-outline--upgraded .mdc-floating-label--float-above,:host .mdc-text-field--textarea .mdc-notched-outline--upgraded .mdc-floating-label--float-above{-webkit-transform:translateY(-130%) scale(0.75);transform:translateY(-130%) scale(0.75);}:host .mdc-text-field--textarea.mdc-notched-outline--upgraded .mdc-floating-label--float-above,:host .mdc-text-field--textarea .mdc-notched-outline--upgraded .mdc-floating-label--float-above{font-size:1rem;}:host .mdc-text-field--textarea .mdc-text-field-character-counter{left:initial;right:16px;position:absolute;bottom:13px;}[dir=rtl]:host .mdc-text-field--textarea .mdc-text-field-character-counter,:host .mdc-text-field--textarea .mdc-text-field-character-counter[dir=rtl]{left:16px;right:initial;}:host .mdc-text-field--textarea .mdc-text-field__input{-ms-flex-item-align:auto;align-self:auto;-webkit-box-sizing:border-box;box-sizing:border-box;height:auto;margin:8px 1px 1px 0;padding:0 16px 16px;border:none;}:host .mdc-text-field--textarea .mdc-text-field-character-counter+.mdc-text-field__input{margin-bottom:28px;padding-bottom:0;}:host .mdc-text-field--textarea .mdc-floating-label{top:17px;bottom:auto;width:auto;pointer-events:none;}:host .mdc-text-field--textarea.mdc-text-field--focused .mdc-notched-outline__leading,:host .mdc-text-field--textarea.mdc-text-field--focused .mdc-notched-outline__notch,:host .mdc-text-field--textarea.mdc-text-field--focused .mdc-notched-outline__trailing{border-width:2px;}:host .mdc-text-field--fullwidth{width:100%;}:host .mdc-text-field--fullwidth:not(.mdc-text-field--textarea){display:block;}:host .mdc-text-field--fullwidth:not(.mdc-text-field--textarea)::before,:host .mdc-text-field--fullwidth:not(.mdc-text-field--textarea)::after{content:none;}:host .mdc-text-field--fullwidth:not(.mdc-text-field--textarea):not(.mdc-text-field--disabled){background-color:transparent;}:host .mdc-text-field--fullwidth:not(.mdc-text-field--textarea) .mdc-text-field__input{padding:0;}:host .mdc-text-field--fullwidth.mdc-text-field--textarea .mdc-text-field__input{resize:vertical;}:host .mdc-text-field--fullwidth.mdc-text-field--invalid:not(.mdc-text-field--disabled):not(.mdc-text-field--textarea){border-bottom-color:#b00020;border-bottom-color:var(--mdc-theme-error,#b00020);}:host .mdc-text-field-helper-line{display:-ms-flexbox;display:flex;-ms-flex-pack:justify;justify-content:space-between;-webkit-box-sizing:border-box;box-sizing:border-box;}.mdc-text-field--dense+:host .mdc-text-field-helper-line{margin-bottom:4px;}.mdc-text-field+:host .mdc-text-field-helper-line{padding-right:16px;padding-left:16px;}:host .mdc-form-field > .mdc-text-field+label{-ms-flex-item-align:start;align-self:flex-start;}:host .mdc-text-field--focused:not(.mdc-text-field--disabled) .mdc-floating-label{color:rgba(98,0,238,0.87);}:host .mdc-text-field--focused .mdc-text-field__input:required ~ .mdc-floating-label::after,:host .mdc-text-field--focused .mdc-text-field__input:required ~ .mdc-notched-outline .mdc-floating-label::after{color:rgba(98,0,238,0.87);}:host .mdc-text-field--focused+.mdc-text-field-helper-line .mdc-text-field-helper-text:not(.mdc-text-field-helper-text--validation-msg){opacity:1;}:host .mdc-text-field--textarea.mdc-text-field--focused:not(.mdc-text-field--disabled) .mdc-notched-outline__leading,:host .mdc-text-field--textarea.mdc-text-field--focused:not(.mdc-text-field--disabled) .mdc-notched-outline__notch,:host .mdc-text-field--textarea.mdc-text-field--focused:not(.mdc-text-field--disabled) .mdc-notched-outline__trailing{border-color:#6200ee;border-color:var(--mdc-theme-primary,#6200ee);}:host .mdc-text-field--invalid:not(.mdc-text-field--disabled):not(.mdc-text-field--outlined):not(.mdc-text-field--textarea) .mdc-text-field__input{border-bottom-color:#b00020;border-bottom-color:var(--mdc-theme-error,#b00020);}:host .mdc-text-field--invalid:not(.mdc-text-field--disabled):not(.mdc-text-field--outlined):not(.mdc-text-field--textarea) .mdc-text-field__input:hover{border-bottom-color:#b00020;border-bottom-color:var(--mdc-theme-error,#b00020);}:host .mdc-text-field--invalid:not(.mdc-text-field--disabled) .mdc-line-ripple{background-color:#b00020;background-color:var(--mdc-theme-error,#b00020);}:host .mdc-text-field--invalid:not(.mdc-text-field--disabled) .mdc-floating-label{color:#b00020;color:var(--mdc-theme-error,#b00020);}:host .mdc-text-field--invalid:not(.mdc-text-field--disabled).mdc-text-field--invalid+.mdc-text-field-helper-line .mdc-text-field-helper-text--validation-msg{color:#b00020;color:var(--mdc-theme-error,#b00020);}:host .mdc-text-field--invalid .mdc-text-field__input{caret-color:#b00020;caret-color:var(--mdc-theme-error,#b00020);}:host .mdc-text-field--invalid .mdc-text-field__input:required ~ .mdc-floating-label::after,:host .mdc-text-field--invalid .mdc-text-field__input:required ~ .mdc-notched-outline .mdc-floating-label::after{color:#b00020;color:var(--mdc-theme-error,#b00020);}:host .mdc-text-field--invalid.mdc-text-field--with-trailing-icon:not(.mdc-text-field--with-leading-icon):not(.mdc-text-field--disabled) .mdc-text-field__icon{color:#b00020;color:var(--mdc-theme-error,#b00020);}:host .mdc-text-field--invalid.mdc-text-field--with-trailing-icon.mdc-text-field--with-leading-icon:not(.mdc-text-field--disabled) .mdc-text-field__icon ~ .mdc-text-field__icon{color:#b00020;color:var(--mdc-theme-error,#b00020);}:host .mdc-text-field--invalid+.mdc-text-field-helper-line .mdc-text-field-helper-text--validation-msg{opacity:1;}:host .mdc-text-field--textarea.mdc-text-field--invalid:not(.mdc-text-field--disabled) .mdc-notched-outline__leading,:host .mdc-text-field--textarea.mdc-text-field--invalid:not(.mdc-text-field--disabled) .mdc-notched-outline__notch,:host .mdc-text-field--textarea.mdc-text-field--invalid:not(.mdc-text-field--disabled) .mdc-notched-outline__trailing{border-color:#b00020;border-color:var(--mdc-theme-error,#b00020);}:host .mdc-text-field--textarea.mdc-text-field--invalid:not(.mdc-text-field--disabled):not(.mdc-text-field--focused) .mdc-text-field__input:hover ~ .mdc-notched-outline .mdc-notched-outline__leading,:host .mdc-text-field--textarea.mdc-text-field--invalid:not(.mdc-text-field--disabled):not(.mdc-text-field--focused) .mdc-text-field__input:hover ~ .mdc-notched-outline .mdc-notched-outline__notch,:host .mdc-text-field--textarea.mdc-text-field--invalid:not(.mdc-text-field--disabled):not(.mdc-text-field--focused) .mdc-text-field__input:hover ~ .mdc-notched-outline .mdc-notched-outline__trailing,:host .mdc-text-field--textarea.mdc-text-field--invalid:not(.mdc-text-field--disabled):not(.mdc-text-field--focused) .mdc-text-field__icon:hover ~ .mdc-notched-outline .mdc-notched-outline__leading,:host .mdc-text-field--textarea.mdc-text-field--invalid:not(.mdc-text-field--disabled):not(.mdc-text-field--focused) .mdc-text-field__icon:hover ~ .mdc-notched-outline .mdc-notched-outline__notch,:host .mdc-text-field--textarea.mdc-text-field--invalid:not(.mdc-text-field--disabled):not(.mdc-text-field--focused) .mdc-text-field__icon:hover ~ .mdc-notched-outline .mdc-notched-outline__trailing{border-color:#b00020;border-color:var(--mdc-theme-error,#b00020);}:host .mdc-text-field--textarea.mdc-text-field--invalid:not(.mdc-text-field--disabled).mdc-text-field--focused .mdc-notched-outline__leading,:host .mdc-text-field--textarea.mdc-text-field--invalid:not(.mdc-text-field--disabled).mdc-text-field--focused .mdc-notched-outline__notch,:host .mdc-text-field--textarea.mdc-text-field--invalid:not(.mdc-text-field--disabled).mdc-text-field--focused .mdc-notched-outline__trailing{border-color:#b00020;border-color:var(--mdc-theme-error,#b00020);}:host .mdc-text-field--outlined.mdc-text-field--invalid:not(.mdc-text-field--disabled) .mdc-notched-outline__leading,:host .mdc-text-field--outlined.mdc-text-field--invalid:not(.mdc-text-field--disabled) .mdc-notched-outline__notch,:host .mdc-text-field--outlined.mdc-text-field--invalid:not(.mdc-text-field--disabled) .mdc-notched-outline__trailing{border-color:#b00020;border-color:var(--mdc-theme-error,#b00020);}:host .mdc-text-field--outlined.mdc-text-field--invalid:not(.mdc-text-field--disabled):not(.mdc-text-field--focused) .mdc-text-field__input:hover ~ .mdc-notched-outline .mdc-notched-outline__leading,:host .mdc-text-field--outlined.mdc-text-field--invalid:not(.mdc-text-field--disabled):not(.mdc-text-field--focused) .mdc-text-field__input:hover ~ .mdc-notched-outline .mdc-notched-outline__notch,:host .mdc-text-field--outlined.mdc-text-field--invalid:not(.mdc-text-field--disabled):not(.mdc-text-field--focused) .mdc-text-field__input:hover ~ .mdc-notched-outline .mdc-notched-outline__trailing,:host .mdc-text-field--outlined.mdc-text-field--invalid:not(.mdc-text-field--disabled):not(.mdc-text-field--focused) .mdc-text-field__icon:hover ~ .mdc-notched-outline .mdc-notched-outline__leading,:host .mdc-text-field--outlined.mdc-text-field--invalid:not(.mdc-text-field--disabled):not(.mdc-text-field--focused) .mdc-text-field__icon:hover ~ .mdc-notched-outline .mdc-notched-outline__notch,:host .mdc-text-field--outlined.mdc-text-field--invalid:not(.mdc-text-field--disabled):not(.mdc-text-field--focused) .mdc-text-field__icon:hover ~ .mdc-notched-outline .mdc-notched-outline__trailing{border-color:#b00020;border-color:var(--mdc-theme-error,#b00020);}:host .mdc-text-field--outlined.mdc-text-field--invalid:not(.mdc-text-field--disabled).mdc-text-field--focused .mdc-notched-outline__leading,:host .mdc-text-field--outlined.mdc-text-field--invalid:not(.mdc-text-field--disabled).mdc-text-field--focused .mdc-notched-outline__notch,:host .mdc-text-field--outlined.mdc-text-field--invalid:not(.mdc-text-field--disabled).mdc-text-field--focused .mdc-notched-outline__trailing{border-color:#b00020;border-color:var(--mdc-theme-error,#b00020);}:host .mdc-text-field--disabled{background-color:#fafafa;border-bottom:none;pointer-events:none;}:host .mdc-text-field--disabled .mdc-text-field__input{border-bottom-color:rgba(0,0,0,0.06);}:host .mdc-text-field--disabled .mdc-text-field__input{color:rgba(0,0,0,0.37);}:host .mdc-text-field--disabled .mdc-floating-label{color:rgba(0,0,0,0.37);}:host .mdc-text-field--disabled+.mdc-text-field-helper-line .mdc-text-field-helper-text{color:rgba(0,0,0,0.37);}:host .mdc-text-field--disabled .mdc-text-field-character-counter,:host .mdc-text-field--disabled+.mdc-text-field-helper-line .mdc-text-field-character-counter{color:rgba(0,0,0,0.37);}:host .mdc-text-field--disabled .mdc-text-field__icon{color:rgba(0,0,0,0.3);}:host .mdc-text-field--disabled:not(.mdc-text-field--textarea){border-bottom-color:rgba(0,0,0,0.12);}:host .mdc-text-field--disabled .mdc-floating-label{cursor:default;}:host .mdc-text-field--textarea.mdc-text-field--disabled{background-color:transparent;background-color:#f9f9f9;}:host .mdc-text-field--textarea.mdc-text-field--disabled .mdc-notched-outline__leading,:host .mdc-text-field--textarea.mdc-text-field--disabled .mdc-notched-outline__notch,:host .mdc-text-field--textarea.mdc-text-field--disabled .mdc-notched-outline__trailing{border-color:rgba(0,0,0,0.06);}:host .mdc-text-field--textarea.mdc-text-field--disabled .mdc-text-field__input{border-bottom:none;}:host .mdc-text-field--focused:not(.mdc-text-field--disabled) .mdc-floating-label{color:#6200ee;color:var(--mdc-theme-primary,#6200ee);}"; }
};

exports.materials_text_area = TextArea;
